<template>
  <div class="bt-container">
    <div v-if="questionResult">
      <el-breadcrumb style="font-size: 24px; margin-top: 40px; margin-bottom: 40px;" separator="|">
        <el-breadcrumb-item :to="{ path: '/a/teacher/NNclass/'+classId }">{{ currentTeachingClass(classId) ? currentTeachingClass(classId).name : '' }}</el-breadcrumb-item>
        <el-breadcrumb-item>{{ questionResult.lectureName }}</el-breadcrumb-item>
        <div style="float: right;">
          <a href="javascript:history.back();">
            <el-button size="small">{{ $t('BOARD.BACK') }}</el-button>
          </a>
        </div> 
      </el-breadcrumb>
      <!--<h2>{{ currentTeachingClass(classId) ? currentTeachingClass(classId).name : '' }} > {{ questionResult.lectureName }}</h2>-->
      <p><strong>{{ questionResult.itemName }}</strong></p>
      <br />
      <div class="basic-info">
        <el-card>
          <el-row>
            <el-col :span="4">{{ $t('RESULT.TOOL_TYPE') }}</el-col>
            <el-col :span="20">
              <span v-if="questionResult.type === '객관'">
                {{ $t('ITEM.QUESTION') }} > {{ $t('QUESTION.MULTI_ANS') }}
              </span>
              <span v-else-if="questionResult.type === '단답'">
                {{ $t('ITEM.QUESTION') }} > {{ $t('QUESTION.SHORT_ANS') }}
              </span>
              <span v-else-if="questionResult.type === '서술'">
                {{ $t('ITEM.QUESTION') }} > {{ $t('QUESTION.ESSAY') }}
              </span>
            </el-col>
          </el-row>
          <div v-if="questionResult.materials.length !== 0">
            <el-row>
              <el-col :span="4">{{ $t('NOTE.IMG') }}</el-col>
              <el-col :span="20">
                <div v-for="material in questionResult.materials" v-bind:key="material">
                  <img
                    :src="getUrl(material.client_path)"
                    width="50%">
                </div>
              </el-col>
            </el-row>
          </div>
          <el-row>
            <el-col :span="4">{{ $t('QUESTION.QUESTION') }}</el-col>
            <el-col :span="20">{{ questionResult.question }}</el-col>
          </el-row>
          <div v-if="questionResult.type === 'SW'">
            <el-row>
              <el-col :span="4">{{ $t('GRADE.SUBMIT_LANG') }}</el-col>
              <el-col :span="20">{{ questionResult.acceptLanguage.join(', ') }}</el-col>
            </el-row>
            <el-row>
              <el-col :span="4">{{ $t('QUESTION.INPUT') }}</el-col>
              <el-col :span="20">{{ questionResult.inputDescription }}</el-col>
            </el-row>
            <el-row>
              <el-col :span="4">{{ $t('QUESTION.OUTPUT') }}</el-col>
              <el-col :span="20">{{ questionResult.outputDescription }}</el-col>
            </el-row>
            <el-row>
              <el-col :span="4">{{ $t('QUESTION.INPUT_SAMPLE') }}</el-col>
              <el-col :span="20">{{ questionResult.sampleInput }}</el-col>
            </el-row>
            <el-row>
              <el-col :span="4">{{ $t('QUESTION.OUTPUT_SAMPLE') }}</el-col>
              <el-col :span="20">{{ questionResult.sampleOutput }}</el-col>
            </el-row>
            <el-row>
              <el-col :span="4">{{ $t('QUESTION.TIME_LIMIT') }}</el-col>
              <el-col :span="20">{{ questionResult.timeLimit }}{{ $t('QUESTION.SECOND') }}</el-col>
            </el-row>
            <el-row>
              <el-col :span="4">{{ $t('QUESTION.MEM_LIMIT') }}</el-col>
              <el-col :span="20">{{ questionResult.memoryLimit }}MB</el-col>
            </el-row>
          </div>
          <el-row v-if="questionResult.type === '객관'">
            <el-col :span="4">{{ $t('QUESTION.CHOICE') }}</el-col>
            <el-col :span="20">
              <span class="choices" v-for="(choice, index) in questionResult.choice" :key="(choice, index)"><span class="index">{{ index + 1 }} .</span> {{ choice }}</span>
            </el-col>
          </el-row>
          <el-row v-if="['객관', '서술', '단답', 'SQL'].includes(questionResult.type)">
            <el-col :span="4">{{ $t('RESULT.CRRT_ANSW') }}</el-col>
            <el-col :span="20">
              <div v-for="(answer) in questionResult.answer" :key="answer">
                {{ answer }}
              </div>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="4">{{ $t('QUESTION.KEYWORD')}}</el-col>
            <el-col :span="20">
              <transition-group type="transition">
                <el-tag class="tag" type="primary" v-for="k in questionResult.keywords" :key="k.keyword">{{ k.keyword }} / {{ k.score_portion }}</el-tag>
              </transition-group>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="4">{{ $t('LECTURE_MANAGE.ALLOTS') }}</el-col>
            <el-col :span="20">{{ questionResult.score }}</el-col>
          </el-row>
        </el-card>
      </div>
      <br />
      <div style="text-align: right">
        <el-button
          v-if="questionResult.type === '서술'"
          type="primary"
          @click="onClick('AUTO_GRADE')"
          >
          {{ $t('QUESTION.AUTO_EVAL') }}
        </el-button>
      </div>
      <br />
      <lecture-question-result
        v-show="isGrading === false"
        :classId="classId"
        :itemId="itemId"
        :resultType="$t('STUDENT_MENU.VIEW_RESULTS')"
      />
      <lecture-question-auto-grading
        v-if="isGrading === true"
      />
    </div>
  </div>
</template>

<style lang="scss" scoped>
  .choices {
    padding-right: 25px;
    .index {
      color: #888888;
    }
  }
  .basic-info {
    .el-row {
      padding-bottom: 10px;
    }
  }
</style>


<script>
  import { mapActions, mapState, mapGetters } from 'vuex';
  import LectureQuestionResult from '../partials/LectureQuestionResult';
  import LectureQuestionAutoGrading from '../partials/LectureQuestionAutoGrading';
  import { EventBus } from '../../event-bus';
  import { baseUrl } from '../../services/config';

  export default {
    name: 'TeacherClassGradingQuestion',
    components: {
      LectureQuestionResult,
      LectureQuestionAutoGrading,
    },
    data() {
      return {
        isGrading: false,
        activeTab: 'question',
      };
    },
    computed: {
      ...mapState('grading', [
        'theResult',
        'questionResult',
      ]),
      ...mapGetters('NNclass', [
        'currentTeachingClass',
      ]),
      classId() {
        const vm = this;
        return Number.parseInt(vm.$route.params.classId, 10);
      },
      itemId() {
        const vm = this;
        return Number.parseInt(vm.$route.params.itemId, 10);
      },
    },
    async created() {
      const vm = this;

      if (!vm.theResult) {
        await vm.getClassTotalResult({
          classId: vm.classId,
        });
      }

      vm.getQuestionResult({
        itemId: vm.itemId,
      });
  
      EventBus.$on('autoGradingComplete', vm.autoGradingComplete);
    },
    methods: {
      ...mapActions('grading', [
        'getClassTotalResult',
        'getQuestionResult',
      ]),
      ...mapActions('NNclass', [
        'putScore',
      ]),
      async scoreSubmit(score, id) { // eslint-disable-line
        const vm = this;
        if (score < 0 || score > vm.questionResult.score) {
          vm.$notify({
            title: vm.$t('NOTIFY.CHCK_GRADE_RANG'),
            message: '',
            type: 'error',
            duration: 2000,
          });
        }
        /*
        const res = await vm.putScore({ id, score });
        if (res && res.status === 200) {
        }
        */
      },
      autoGradingComplete() {
        this.isGrading = false;
      },
      onClick(type) {
        const vm = this;
        switch (type) {
          case 'AUTO_GRADE':
            vm.isGrading = true;
            break;
          default: {
            throw new Error(`not defined type ${type}`);
          }
        }
      },
      getUrl(arg) {
        return baseUrl + arg;
      },
    },
  };
</script>
